---
title: CSS Object Model (CSSOM)
slug: Web/API/CSS_Object_Model
tags:
  - API
  - CSSOM
  - Overview
  - Reference
---
<p>{{DefaultAPISidebar("CSSOM")}}</p>

<p class="summary">The <strong>CSS Object Model</strong> is a set of APIs allowing the manipulation of CSS from JavaScript. It is much like the DOM, but for the CSS rather than the HTML. It allows users to read and modify CSS style dynamically.</p>

<h2 id="Reference">Reference</h2>

<div class="index">
<ul>
 <li>{{DOMxRef("AnimationEvent")}}</li>
 <li>{{DOMxRef("CaretPosition")}}</li>
 <li>{{DOMxRef("CSS")}}</li>
 <li>{{DOMxRef("CSSCharsetRule")}}</li>
 <li>{{DOMxRef("CSSConditionRule")}}</li>
 <li>{{DOMxRef("CSSCounterStyleRule")}}</li>
 <li>{{DOMxRef("CSSFontFaceRule")}}</li>
 <li>{{DOMxRef("CSSFontFeatureValuesMap")}}</li>
 <li>{{DOMxRef("CSSFontFeatureValuesRule")}}</li>
 <li>{{DOMxRef("CSSGroupingRule")}}</li>
 <li>{{DOMxRef("CSSImportRule")}}</li>
 <li>{{DOMxRef("CSSKeyframeRule")}}</li>
 <li>{{DOMxRef("CSSKeyframesRule")}}</li>
 <li>{{DOMxRef("CSSMarginRule")}}</li>
 <li>{{DOMxRef("CSSMediaRule")}}</li>
 <li>{{DOMxRef("CSSNamespaceRule")}}</li>
 <li>{{DOMxRef("CSSPageRule")}}</li>
 <li>{{DOMxRef("CSSRule")}}</li>
 <li>{{DOMxRef("CSSRuleList")}}</li>
 <li>{{DOMxRef("CSSStyleDeclaration")}}</li>
 <li>{{DOMxRef("CSSStyleSheet")}}</li>
 <li>{{DOMxRef("CSSStyleRule")}}</li>
 <li>{{DOMxRef("CSSSupportsRule")}}</li>
 <li>{{DOMxRef("CSSVariablesMap")}}</li>
 <li>{{DOMxRef("CSSViewportRule")}}</li>
 <li>{{DOMxRef("ElementCSSInlineStyle")}}</li>
 <li>{{DOMxRef("FontFace")}}</li>
 <li>{{DOMxRef("FontFaceSet")}}</li>
 <li>{{DOMxRef("FontFaceSetLoadEvent")}}</li>
 <li>{{DOMxRef("GeometryUtils")}}</li>
 <li>{{DOMxRef("GetStyleUtils")}}</li>
 <li>{{DOMxRef("LinkStyle")}}</li>
 <li>{{DOMxRef("MediaList")}}</li>
 <li>{{DOMxRef("MediaQueryList")}}</li>
 <li>{{DOMxRef("MediaQueryListEvent")}}</li>
 <li>{{DOMxRef("Screen")}}</li>
 <li>{{DOMxRef("StyleSheet")}}</li>
 <li>{{DOMxRef("StyleSheetList")}}</li>
 <li>{{DOMxRef("TransitionEvent")}}</li>
</ul>
</div>

<p>Several other interfaces are also extended by the CSSOM-related specifications: {{DOMxRef("Document")}}, {{DOMxRef("Window")}}, {{DOMxRef("Element")}}, {{DOMxRef("HTMLElement")}}, {{DOMxRef("HTMLImageElement")}}, {{DOMxRef("Range")}}, {{DOMxRef("MouseEvent")}}, and {{DOMxRef("SVGElement")}}.</p>

<h3 id="CSS_Typed_Object_Model">CSS Typed Object Model {{Experimental_Inline}}</h3>

<p>{{SeeCompatTable}}</p>

<div class="index">
<ul>
 <li>{{DOMxRef("CSSImageValue")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSKeywordValue")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSMathInvert")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSMathMax")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSMathMin")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSMathNegate")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSMathProduct")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSMathSum")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSMathValue")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSMatrixComponent")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSNumericArray")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSNumericValue")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSPerspective")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSPositionValue")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSRotate")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSScale")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSSkew")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSSkewX")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSSkewY")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSStyleValue")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSTransformComponent")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSTransformValue")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSTranslate")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSUnitValue")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSUnparsedValue")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("CSSVariableReferenceValue")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("StylePropertyMap")}} {{Experimental_Inline}}</li>
 <li>{{DOMxRef("StylePropertyMapReadOnly")}} {{Experimental_Inline}}</li>
</ul>
</div>

<h3 id="Obsolete_CSSOM_interfaces">Obsolete CSSOM interfaces {{Obsolete_Inline}}</h3>

<p>{{Obsolete_Header}}</p>

<div class="index">
<ul>
 <li>{{DOMxRef("CSSPrimitiveValue")}} {{Obsolete_Inline}}</li>
 <li>{{DOMxRef("CSSValue")}} {{Obsolete_Inline}}</li>
 <li>{{DOMxRef("CSSValueList")}} {{Obsolete_Inline}}</li>
</ul>
</div>

<h2 id="Tutorials">Tutorials</h2>

<ul>
 <li><a href="/en-US/docs/Determining_the_dimensions_of_elements">Determining the dimensions of elements</a> (it needs some updating as it was made in the DHTML/Ajax era).</li>
 <li><a href="/en-US/docs/Web/API/CSS_Object_Model/Managing_screen_orientation">Managing screen orientation</a></li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("CSS Typed OM")}}</td>
   <td>{{Spec2("CSS Typed OM")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("CSS Painting API")}}</td>
   <td>{{Spec2("CSS Painting API")}}</td>
   <td>Extended the {{DOMxRef("CSS")}} interface with the {{DOMxRef("CSS.paintWorklet","paintWorklet")}} static property.</td>
  </tr>
  <tr>
   <td>{{SpecName("CSSOM View")}}</td>
   <td>{{Spec2("CSSOM View")}}</td>
   <td>Defined the {{DOMxRef("Screen")}} and {{DOMxRef("MediaQueryList")}} interfaces and the {{DOMxRef("MediaQueryListEvent")}} event and {{DOMxRef("MediaQueryListListener")}} event listener.</td>
  </tr>
  <tr>
   <td>{{SpecName("CSSOM")}}</td>
   <td>{{Spec2("CSSOM")}}</td>
   <td>Extended the {{DOMxRef("CSS")}} interface and provides the base for the modern CSSOM specification.</td>
  </tr>
  <tr>
   <td>{{SpecName("Screen Orientation")}}</td>
   <td>{{Spec2("Screen Orientation")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("CSS3 Fonts")}}</td>
   <td>{{Spec2("CSS3 Fonts")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("CSS3 Animations")}}</td>
   <td>{{Spec2("CSS3 Animations")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("CSS3 Transitions")}}</td>
   <td>{{Spec2("CSS3 Transitions")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("CSS3 Variables")}}</td>
   <td>{{Spec2("CSS3 Variables")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("CSS3 Conditional")}}</td>
   <td>{{Spec2("CSS3 Conditional")}}</td>
   <td>Defined the {{DOMxRef("CSS")}} interface.</td>
  </tr>
  <tr>
   <td>{{SpecName("CSS3 Device")}}</td>
   <td>{{Spec2("CSS3 Device")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("CSS3 Counter Styles")}}</td>
   <td>{{Spec2("CSS3 Counter Styles")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("DOM2 Style")}}</td>
   <td>{{Spec2("DOM2 Style")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>All these features have been added little by little over the years to the different browsers: it was a quite complex process that can't be summarized in a simple table. Please refer to the specific interfaces for its availability.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Document_Object_Model">Document Object Model (DOM)</a></li>
 <li><a href="/en-US/docs/Web/Houdini/">Houdini</a></li>
</ul>
